<template>
  <div class="login">
    <div class="login-box">
      <div class="login-hd">
        <h2 class="login-title">绑定</h2>
      </div>
      <div class="login-bd">
        <div class="login-form">
          <!-- 账号登录 -->
          <account-login ref="form" @submit="onSubmit"></account-login>
          <!-- 验证码登录 -->
          <!-- <code-login ref="form" @submit="onSubmit"></code-login> -->
          <div class="login-button" @click="handleSubmit">立即绑定</div>
        </div>
      </div>
      <div class="login-ft">
        <p class="login-tips">
          登录遇到困难？请点击
          <span class="forget-password" @click="passwordVisible = true">找回密码</span>
        </p>
      </div>
    </div>
  </div>
</template>
<script>
import Cookies from 'js-cookie'

import * as api from '@/api/account'
import AccountLogin from './accountLogin.vue'
import CodeLogin from './codeLogin.vue'

export default {
  components: { AccountLogin, CodeLogin },
  data() {
    const UA = navigator.userAgent.toLowerCase()
    return {
      ruleForm: {
        type: 1,
        account: '',
        password: '',
        RememberMe: true,
        service: 'https://h5.ezijing.com'
      },
      passwordVisible: false,
      isWechat: /micromessenger/.test(UA),
      unionid: Cookies.get('wechat_login_no_phone_error')
    }
  },
  computed: {
    // 重定向地址
    redirectURI() {
      const { query } = this.$route
      return query.redirect_uri ? decodeURIComponent(query.redirect_uri) : ''
    }
  },
  methods: {
    handleSubmit() {
      this.$refs.form.submit()
    },
    // 提交
    onSubmit(data) {
      this.unionid ? this.bindWechat(data) : this.loginRequest(data)
    },
    // 登录
    loginRequest(data) {
      const params = Object.assign({}, this.ruleForm, data)
      api
        .login(params)
        .then(response => {
          this.loginSuccess(response)
        })
        .catch(error => {
          error.response && this.$toast(error.response.data.message)
        })
    },
    // 绑定微信并登录
    bindWechat() {
      const data = Object.assign({}, this.ruleForm, { unionid: this.unionid })
      api
        .bindWechat(data)
        .then(response => {
          this.loginSuccess(response)
        })
        .catch(error => {
          error.response && this.$toast(error.response.data.message)
        })
    },
    // 登录成功
    loginSuccess(response) {
      if (response.code === 0) {
        Cookies.remove('wechat_login_error', { domain: '.ezijing.com' })
        Cookies.remove('wechat_login_no_phone_error', {
          domain: '.ezijing.com'
        })
        if (this.redirectURI) {
          window.location.href = this.redirectURI
        } else {
          this.$router.replace('/')
        }
        // this.$router.replace('/')
      } else {
        this.$toast(response.msg)
      }
    },
    wechatLogin() {
      const appId = 'wx451c01d40d090d7a'
      // 回调地址
      const redirectURI = `${process.env.VUE_APP_WECHAT_REDIRECT_URL}?needCheck=false&identity=friend&redirectUrl=${window.location.origin}`
      // 微信的地址
      console.log(redirectURI)
      const wechatUrl = `https://open.weixin.qq.com/connect/oauth2/authorize?appid=${appId}&redirect_uri=${encodeURIComponent(
        redirectURI
      )}&response_type=code&scope=snsapi_userinfo&state=STATE#wechat_redirect`
      // 打开地址
      window.location.href = wechatUrl
    },
    checkWechatLogin() {
      return !!(
        Cookies.get('wechat_login_error') ||
        Cookies.get('wechat_login_no_phone_error')
      )
    }
  },
  created() {
    // if (this.isWechat && !this.checkWechatLogin()) {
    //   this.wechatLogin()
    // }
  }
}
</script>
<style lang="scss">
.login {
  position: relative;
  min-height: 100vh;
  display: flex;
  flex-direction: column;
  background: url('../../assets/images/login_bg.png') no-repeat;
  background-size: contain;
}
.login-box {
  position: absolute;
  top: 100px;
  left: 50px;
  right: 50px;
  height: 400px;
  padding: 20px;
  background: rgba(255, 255, 255, 1);
  box-shadow: 0px 10px 20px 0px rgba(0, 0, 0, 0.1);
  border-radius: 20px;
}
.login-hd {
  padding: 10px 0;
}
.login-title {
  display: inline-block;
  font-size: 24px;
  color: #2b7ce9;
  border-bottom: 5px solid #2b7ce9;
}
.login-bd {
  margin-top: 20px;
  flex: 1;
}
.login-button {
  margin-top: 20px;
  height: 40px;
  font-size: 12px;
  color: #fff;
  line-height: 40px;
  background: linear-gradient(
    270deg,
    rgba(43, 124, 233, 1) 0%,
    rgba(103, 168, 255, 1) 100%
  );
  text-align: center;
  border-radius: 3px;
  cursor: pointer;
}
.login-ft {
  padding: 40px 0;
}
.login-tips {
  text-align: center;
  font-size: 12px;
  color: #999;
  .forget-password {
    color: #1989fa;
  }
}
.login {
  .van-field {
    margin-bottom: 20px;
    padding: 0;
    flex-direction: column;
  }
  .van-field__label {
    font-size: 12px;
    color: #222;
    margin-bottom: 5px;
    padding-left: 10px;
  }
  .van-field__control {
    padding: 8px;
    border: 1px solid #ccc;
    border-radius: 3px;
  }
}
</style>
